2005-12-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.99 released.

2005-12-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source_merge.C: New model.
	* Makefile (MODELS): Added it.

	* xysource_merge.C (load): Fix bug that prevented inheriting 'with'.

2005-12-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* stringer.C (const): New model.

2005-12-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (get_string): Handle backslash after a backslashed
	newline.

	* lexer_table.C (read_header): Don't apply filter on dim line.

2005-12-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* block.C (ScopeBlock): New scope.
	(expand_string): Use it.

	* boolean.C, stringer.C, stringer.h, boolean.h:
	* number.h, number.C, number_arit.C, number_const.C, number_soil.C
	(initialize): New virtual member function.
	* parser_file.C (get_number): Call it.
	* source_expr.C, source_combine.C (load): Ditto.
	* xysource_combine.C, xysource_loop.C, xysource_expr.C (load): Ditto.

	* number_source.C: New file.
	* Makefile (MODELS): Added it.

	* stringer.C (value, dimension): New models.

2005-12-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program_file.C (write): New model.

2005-12-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.98 released.

2005-12-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_flux_bottom.C (to): New parameter.
	* select_flux_top.C (from): New parameter.

2005-12-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* sample/DrainDrying.dai: New file.
	* sample/Makefile (SETUPS): Added it.

2005-12-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (~Implementation): Remove test that lexer is not
	NULL.  If there were problems opening the file, it might be NULL.

2005-11-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* boolean.C (and, or, xor, not): New models.

2005-11-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (harvest): Don't emerge twice.

	* Version 3.97 released.

2005-11-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program_batch.C (run): delete before erase.

	* transport_none.C: Clear bottom flux.

2005-11-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.96 released.

2005-11-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (MODELS): Added it.

	* program_file.C: New file.

	* Version 3.95 released.

2005-11-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lexer_table.C (good): Close file descriptor after first problem.

	* column_base.C (initialize_common): Check weather later.
	* column_std.C (initialize): Ditto.

	* number_soil.C ("depth_Theta", "depth_K"): New models.

2005-11-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_table.C: New model.

2005-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source_combine.C (load): Warn against errorbars.

2005-11-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.94 released.

2005-11-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C (standard_conversions): [m/s] -> [cm/d].

2005-11-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* xysource_merge.C: New model.
	* Makefile (MODELS): Added.

	* gnuplot_utils.C, gnuplot_utils.h: New utility.
	* Makefile (OTHER): Added it.
	* xysource_combine.C (XYSourceCombineSyntax): Use it.
	* xysource_loop.C (XYSourceLoopSyntax): Ditto.


2005-11-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lexer.C, lexer.h (warning, error): Use proper Treelog functions.
	* lexer.C, lexer.h, lexer_table.C, lexer_table.h (debug): New function.

	* xysource_inline.C: 
	* number_soil.C, xysource_loop.C, xysource_combine.C: New models.
	* Makefile (MODELS): Add them.

	* scope_sources.h, scope_sources.C: New utility.
	* Makefile (OTHER): Added them.
	* source_combine.C: Use it.

	* gnuplot_base.C, gnuplot_base.h: New base model.
	* Makefile (SPECIALS): Add it.
	* gnuplot_time.C: Use it,
	* gnuplot_xy.C: New model.
	* xysource_expr.C: New model.
	* Makefile (MODELS): Add them.

2005-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* xysource.C, xysource.h: New component.
	* Makefile (COMPONENTS): Add it.

	* scope_table.C, scope_table.h: New utility.
	* lexer_table.C, lexer_table.h: New utility.
	* Makefile (OTHER): Added them.
	* source_file.h, source_file.C, source_std.h, source_std.C:
	* source_expr.h, source_expr.C: Use them.

	* Version 3.93 released.

2005-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/tutorial.tex (Plotting simulation results): Updated gnuplot
	syntax.

	* source.C (description): Really a time series.

	* gnuplot.C, gnuplot.h: New component.
	* Makefile (COMPONENTS): Add it.
	* gnuplot_multi.C, gnuplot_time.C: New models.
	* Makefile (MODELS): Add them.

2005-11-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.92 released.

2005-11-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program_gnuplot.C (legend): Support "none" keyword.

	* Version 3.91 released.

2005-11-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program_gnuplot.C (ProgramGnuplotSyntax): User should specify
	dimension for y axis.

2005-11-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C (Convert_kPa_pF): New class.
       (standard_conversions): [kPa] -> [pF].
	
2005-11-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.90 released.

2005-11-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (load_list): Support '&old' keyword.

	* program_batch.C (run): Tell user more about each program started.

	* Version 3.89 released.

2005-11-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source_file.C (add_entry, ebar): New functions.
	* source_expr.C, source_std.C: Support them.
	* program_gnuplot.C (run): Ditto.

2005-11-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.88 released.

2005-11-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source_file.C (Filter::match): Reversed logic for padding.

	* Version 3.87 released.

2005-11-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source_file.C (Filter::match): New function.
	(read_entry): Use it.

	* Version 3.86 released.

2005-11-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source_file.C (get_time): Accept dd/mm/yy format.

	* source_combine.C: New model.
	* Makefile (MODELS): Added.

2005-11-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.85 released.

2005-10-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* boolean.C (true, false): New models.

	* horizon_numeric.C, horizon_system.C: (normalize): New parameter.

2005-10-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* treelog.C, treelog.h (sequence_id): New global function.

	* boolean.C, boolean.h: New component.
	* stringer.h, stringer.C: New component.
	* Makefile (COMPONENTS): Added them.

2005-10-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* submodeler.h: New utility.

2005-10-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log-std.dai (column): New base parameterization.
	("Field water", "Soil water", "Field nitrogen", "Soil nitrogen"):
	Use it.

	* librarian, select, log: Support lexical scope.
	
2005-10-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* block.C: New utility.
	* Makefile (OTHER): Added it.

	* syntax.C, syntax.h (category_names, category_name, category_number)
	(type_names, type_name, type_number): Use 'std::string'
	instead of 'char*'.

	* soil.C (initialize): Fixed comparison of signed and unsigned.

2005-10-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C (initialize): Fixed comparison of signed and unsigned.
	* syntax.C (total_order): Ditto.
	* library.C (all_count): Ditto.

	* library.h, library.C, librarian.h, librarian.C, 
	* alist.h, alist.C: Removed 'const char* key' variants.

2005-10-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_M_BaC.C (h_b): Added check.

	* parser_file.C (load_derived): Spelling error.

2005-10-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/fertilizer.dai: Added dimensions.

2005-10-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* condition_time.C (timestep): New condition.

	* units.C (standard_conversions): [none] -> [].

2005-10-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lexer.C (get): Support DOS files under Unix.

2005-09-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* timestep.h, memutils.h: New utility headers.
	* Makefile (HEADERS): added
	(OTHER): Removed 'common.C'.

2005-09-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Removed TmpStream.

2005-09-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.84 released.

2005-09-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.83 released.

2005-09-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source_file.C: New model base.
	* Makefile (SPECIALS): Added.

2005-09-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (load_derived): Special support for Number objects.

	* weather_std.C: Handle missing timestep better (I hope).

	* units.C (standard_conversions): [g CO2-C/cm^2] -> [CO2/m^2]
	(multiply): [g CO_2-C/cm^3/h] * [cm] = [g CO_2-C/cm^2/h]
	* lib/log.dai ("Crop Photosynthesis"): Use spec.
	* production.C (RootRespiration): Fixed dimension.

	* number_arit.C: New model.
	* source_expr.C: New model.
	* Makefile (MODELS): Added them.
	
2005-09-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source_std.C: New model.
	* source.C, source.h: Made it a component.
	* Makefile (COMPONENTS, MODELS): Added it.
	(SUBMODELS): Removed it.

	* parser.h (class Parser): explicit.

	* parser_file.C: Use ostringstream instead of TmpStream.

	* Version 3.82 released.

2005-09-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* source.C, source.h: New submodel.
	* Makefile (SUBMODELS): Added it.

	* Version 3.81 released.

2005-09-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.80 released.

2005-09-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* format_LaTeX.h: New interface.
	* Makefile (MODELS): Removed.
	(SPECIALS): Added.

2005-09-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_crop.C: Use ostringstream instead of TmpStream.
	* action_fertilize.C: Ditto.
	* action_irrigate.C: Ditto.
	* action_markvand.C: Ditto.
	* action_wait.C: Ditto.
	* am.C: Ditto.
	* assertion.C: Ditto.
	* bioclimate_std.C: Ditto.
	* check_range.C: Ditto.

	* check_range.C: Don't use namespace std.

	* alist.h, alist.C (name_sequence): New accessor.

2005-09-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/Makefile (exercises.pdf): Depfix.

	* Version 3.79 released.

2005-09-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_harvest.C: Moved water and N stress last.

2005-08-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* condition_soil.C (soil_inorganic_N_above): New condition.

2005-08-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.h (class Daisy): Made constructor explicit.

2005-08-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* dlf.C, dlf.h: New utility.
	* Makefile (OTHER): Added it.

	* lib/log-std.dai ("Soil nitrogen"): Fix "where" parameter.

	* log_table.C (print_header): Support new "fixed" value.

2005-08-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.78 released.

2005-08-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.h, harvesting.C (operator ()): New 'combine' parameter.
	* crop_old.C, crop_sold.C, crop_simple.C:
	* crop.h, crop_crop_std.C (harvest): Update caller.
	* crop.C (kill): Update caller.
	* vegetation.h, vegetation_crops.C, vegetation_permanent.C
	(harvest): Update caller. 
	* column.h, column_base.h, column_base.C (harvest): Update caller.
	* field.C, field.h (harvest): Update caller.
	* action_harvest.C (combine): New parameter.
	* action_crop.C, action_harvest.C (doIt): Update caller.

	* crpn.h (nitrogen_stress_days): Made it public.
	* harvest.h, harvest.C (water_stress_days, nitrogen_stress_days):
	New harvest data. 
	* harvesting.C, harvesting.h (operator ()): Update caller.
	* crop_old.C, crop_sold.C, crop_simple.C, crop_std.C (harvest):
	Update caller. 
	* log_harvest.C (match): Log them.

	* root_system.C (output): Don't output 'water_stress_days' twice!

2005-08-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_markvand.C: Added checks.

2005-08-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.77 released.

2005-08-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C: Normalize day cycle.

2005-08-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/markvand.dai: New parameter library.

2005-08-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.h, vegetation_permanent.C, vegetation_crops.C:
	* column.h, column_base.C, field.h, field.C (crop_names): New
	member function.

2005-08-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pet.C (reference_to_potential): Use cover instead of LAI.

2005-08-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_none.C, weather_std.C:
	* weather.h, weather_simple.C (daily_precipitation): New function.

2005-08-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C, bioclimate.h (daily_precipitation): New
	virtual member function.
	* column_base.C, column_base.h, column.h (daily_precipitation,
	daily_global_radiation):  Ditto.
	* field.h, field.C (daily_precipitation, daily_global_radiation):
	Ditto. 

	* action_markvand.C: New model.
	* Makefile (MODELS): Added it.

	* condition_crop.C (ConditionDSAfter::match): Added const

2005-08-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (load_syntax): New 'frac_desc' parameter.
	* aom.C, smb.C, som.C (load_syntax): Update caller.

2005-07-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lexer_data.h: Fixed comment.

2005-07-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.76 released.

2005-07-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Weather"): Removed bogus column.

	* weather_std.C (read_new_day): Fix calculation of time for
	minimum temperature.

2005-07-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (load_derived): Support default type for backward
	compatibility. 

	* photosynthesis.C, photosynthesis.h: Removed submodel.
	* photo.C, photo.h: New component.
	* photo_GL.C: New model.
	* Makefile (MODELS, COMPONENTS, SUBMODELS): Updated.

2005-07-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program_gnuplot.C: New model.

2005-06-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.75 released.

2005-06-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_harvest.C (doIt): Disable check for emergence when
	harvesting "all". 

2005-06-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_interval.C, select.h (check_border): New virtual member
	function. 
	* log_select.C (check): Call it.

2005-06-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil.C (border): New parameter.

2005-06-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.h, weather.C, weather_std.C (initialize): Made it return
	true on success.
	* column_base.C (initialize_common): Ditto.
	* daisy.C, column_inorganic.C, column_std.C (initialize): Update

2005-05-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C (initialize): Fixed problem with initialization
	order when using column specific weather.

2005-05-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vcheck.C, vcheck.h (Enum::Enum): Handle up to six parameters.

	* select.h (Handle::geometric): New handle type.
	* select_interval.C, select.C, select_array.C, select_value.C: Use it.

	* hydraulic_hypres.C (initialize): Fixed formula for alpha_star.
	Reported by Charlotte Tofteng.

2005-05-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_interval.C (density_factor): New variable.
	(density): Removed.

	* lib/dk-horizon.dai: Don't divide sand in fine and coarse.

2005-05-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.74 released.

2005-05-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Removed bogus assertion that prevented
	pressure bottom from working.

2005-05-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.73 released.

2005-04-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* treelog.C, treelog.h (lazy): New virtual member function.
	* options.C (copyright): Use it.
	
	* select.C (initialize): Don't convert accumulated timestep units.

2005-05-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.72 released.

2005-05-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* phenology.C, phenology.h (DAP): New state variable.
	* crop_std.C (tick): Update it.
	* photosynthesis.C (DAPEff): New parameter.

2005-04-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/Makefile (DAISY): Removed dk-soil.dai.

	* Version 3.71 released.

2005-04-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* symbol.C: Added assertions.
	* summary_balance.C (period): New parameter.

2005-03-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.C (Spec::description, Spec::refer): New member function.
	(Spec::check_path): Ditto.
	(Spec::check_alist): Call it.
	(document): New member function.

	* program_document.C (submodel): Removed member variable.

2005-03-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* library.C, library.h (has_interesting_description): New member
	function. 
	* program_document.C (has_interesting_description): Removed.
	* log_select.C (has_interesting_description): Removed.

	* select.C (check_alist): Fix warning.
	(load_syntax): Fix typo in desctiption string.

	* select.C, select.h (log_name): Removed.
	(document): New member function.
	* log_select.C (document_entries): Call it.

2005-03-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_irrigate.C (ActionIrrigateSubsoilStart): Removed
	(ActionIrrigateStop): Ditto.

	* field.C, field.h (set_subsoil_irrigation): Removed.

	* column_std.C (irrigate_subsoil): Add solute to fertilizer log.

	* column.h, column_base.C, column_std.C (set_subsoil_irrigation):
	Removed. 

	* bioincorporation.C (N_added, C_added): Fixed dimension.

2005-03-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C (standard_conversions): Added a couple of convertions
	for log variables.

	* phenology_std.C, phenology.h, phenology.C (mature): New member
	function. 
	* crop_std.C (tick): Use it.

2005-03-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* path.C (set_directory): Attempt to create directory if chdir
	fails. 

2005-03-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon_std.C (HorizonStandardSyntax): Added warning for using
	fine and coarse sand.

2005-03-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* sample/dk-soil.dai: Moved here.
	* sample/Makefile (LIBS): Added.
	* lib/dk-soil.dai: From here.
	* lib/Makefile (REMOVE): Added.
	* sample/dk-soil.dai (Jyndevad, (Askov): New columns.
	
2005-02-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.70 released.

2005-02-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program_document.C (print_sample_entry): Print dimension.

	* action_irrigate.C (struct ActionIrrigate): Write N amount.

	* column_std.C (fertilize): Split out variant that takes an 'IM'
	object.
	(irrigate_surface, irrigate_overhead): Use it.

2005-02-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* xref.C (use_model): Don't use components here.
	(enter_parameter): Always use them here.

	* Version 3.69 released.

2005-02-23  Per Abrahamsen  <abraham@dina.kvl.dk>


	* groundwater.h, groundwater.C (initialize): Made it a pure virtual.
	* groundwater_lysimeter.C (initialize): Implement it.
	(location): New member variable.
	(table): Use it.

	* uzrichard.C (richard): Use a fake pressure bottom when the
	lysimeter is active.

2005-02-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.C: New 'hydraulic' program.

2005-02-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C (has_vapor_pressure): Also trigger if
	has_relative_humidity. 

2005-02-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program_refdoc.C: Removed.
	* document_LaTeX.C, document.C, document.h: Removed.
	* Makefile (COMPONENTS, MODELS): Updated.

2005-01-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* sample/log-sample.dai ("Sample water content"): New sample.

2005-01-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C (common_done): Time columns now obey
	'field_separator'. 

2005-01-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program_document.C: New model.

2005-01-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* format.C, format.h: New component.
	* Makefile (COMPONENTS): Add it.
	* format_LaTeX.C: New model.
	* Makefile (MODELS): Add it.
	* document.C, document.h (format): New parameter.
	* program_refdoc.C (run): Update caller.

	* xref.C (enter_parameter): Removed bogus assertions.

2005-01-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/Makefile (DOCS): Add it.

	* txt/notes.tex: New file.

2005-01-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* canopy_std.C (SpLAIfac, SpSOrgAI): Fixed description.

2005-01-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.68 released.

2005-01-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C: Use depth component for aquifer.
	* lib/log.dai ("Groundwater"): Update caller.

2005-01-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* depth.C: New component.
	* Makefile (COMPONENTS): Add it.

	* average_harmonic.C, average_geometric.C, average_arithmetic.C:
	Removed. 
	* Makefile (MODELS, REMOVE): Ditto.
	* average.C: Added models here.

2005-01-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C, log_harvest.C: Delay open file to initialization point.

	* path.C, path.h (get_directory): New function.
	* path.h (InDirectory): New class.
	* program_batch.C (check, run, initialize): Use it.

	* weather_std.C: Changed "kgN/year" to "kgN/ha/year".
	* units.C (standard_conversions): Convert old value to new.
	* txt/dwf.tex: Doc fix.
	Reported by Charlotte Tofteng <cto@kvl.dk>.

2005-01-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_hypres.C (HydraulicHypresSyntax): Fixed web
	reference. 
	Reported by Peter van der Keur <pke@geus.DK>.

2005-01-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* sample/batch.dai: New setup.
	* sample/Makefile (SETUPS): Add it.

2004-12-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.67 released.

2004-12-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wse.C, wse.h: New component.
	* Makefile (COMPONENTS): Add it.
	* crop_std.C: Use it.

2004-12-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log.h, log.C  (initialize): Made it a pure virtual member.
	* log_clone.C, log_table.C, log_harvest.C, log_alist.C
	(initialize): Implement. 

	* program_file.C: New model.
	* Makefile (MODELS): Add it.
	* program_batch.C: New model.
	* Makefile (MODELS): Add it.

	* log_table.C, log_alist.h, log_alist.C, log_select.C:
	* log.h, log_harvest.C (check): Removed 'Syntax' argument.

	* program.h, program_refdoc.C, am.C (initialize, check): New
	virtual member functions. 
	* daisy.C, daisy.h: Made it a program model.
	* main.C (main): Update caller.

2004-12-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.66 released.

2004-12-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* program.C, program.h: New component.
	* Makefile (COMPONENTS): Add it.
	* options.C: Use it.
	* program_refdoc.C: New model.
	* Makefile (MODELS): Add it.
	* library.C, library.h: Remove support for command line arguments.
	* am.C (command_table): Made it a program.

	* geometry.C (initialize_layer): Don't fill out array with 0.0.
	* weather_none.C (snow_value): Give it a default value.

2004-12-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.C (negate): New parameter.
	* summary_balance.C (summarize): New model.
	* Makefile (MODELS): Add it.
	* lib/log-std.dai: New parameter file.
	* lib/Makefile (DAISY): Add it.
	* lib/all.dai (file): Add it.

2004-12-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* fetch.C: New submodel.
	* Makefile (SUBMODELS): Add it.
	* summary_simple.C: Use it.

	* document.C, document_LaTeX.C, document.h (print_submodel_entry):
	Made it a base class function.
	(print_submodel_entries): Renamed from 'print_entries'.

	* xref.C (enter_parameter): Ignore inherited values.

2004-12-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* library.C (base_model): Handle "base_model" attribute.
	(is_derived_from, ): Ditto.
	* document.C, document.h, document_LaTeX.C: Ditto.
	* select.C, horizon.C: Use it.

2004-12-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (GroundwaterPipeSyntax): Don't call
	'Groundwater::load_syntax'. 
	* weather_simple.C (reference_evapotranspiration_value):
	(precipitation_value): New parameters.
	(reference_evapotranspiration, precipitation): Don't overwrite.
	* weather_none.C (reference_evapotranspiration_value, rain_value):
	(snow_value): New parameters..
	(reference_evapotranspiration, rain, snow): Don't overwrite.
	
	* horizon.C (HorizonSyntax): Mark it as a base model.
	* librarian.h (add_base): New static member function.
	* library.C, library.h (add_base): New member function.


2004-12-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/exercises.tex: Don't use 'default' horizon.

2004-12-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* production.C, production.h (update_carbon): New member function.
	* production.C (tick): Call it.
	* harvesting.C (operator ()): Call it.

	* Version 3.65 released.

2004-12-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_flux_top.C (output_array): Fix off by one array check
	(found by valgrind).

	* select_array.C (result): Make it persistent, since log_table.C
	requires that.
	* log_table.C (dest_array, dest_number, dest_name): Initialize.
	(common_done): Add check.

	* Version 3.64 released.

2004-12-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C (standard_conversions): Add 'Syntax::None ()' to []
	conversion. 

2004-12-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.64 released.

2004-12-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* sample/init-soil.dai: New file.
	* sample/Makefile (LIBS): Add it.

	* parser_file.C (check_dimension): Allow conversions with
	'Syntax::Fraction ()' and 'Syntax::None ()'.

	* units.C (standard_conversions): [g/cm^3] -> [].
	* geometry.C (add_layer): Handle fractions.
	* solute.C (C): Use it.
	(solute_ppm, soil_ppm): Removed.
	(Ms): New parameter.

2004-12-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C (add): Automatically add reverse conversion.

	* hydraulic.C (load_Theta_sat, load_Theta_res): Use fraction
	instead of [cm^3 H2O/cm^3].
	* units.C (standard_conversions): Support [cm^3 H2O/cm^3] as
	synonym for [].

2004-11-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* printer_file.h, printer_file.C (print_parameterization): New
	member. 
	* document.h, document_LaTeX.C (print_parameterization_content):
	New member function.
	* document.C (print_model): Call it.

2004-11-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_min.C, select_max.C, select_average.C, FILES: Removed.
	* Makefile (MODELS, TEXT): Remove them.
	(REMOVE): Add them.

	* select.h, select.C, summary_simple.C (flux, handle): Replaced
	'flux' with more general 'handle' parameter.
	* select_value.C, select_value.h, select_interval.C:
	* select_flux_top.C, select_flux_bottom.C, select_index.C: 
	* select_content.C, select_number.C: Update caller.

	* lib/log.dai ("Old Crop Production"): Fixated is a flux.

	* organic_matter.C (abiotic_factor): New log variable.

2004-11-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (partition): Don't add to a closed stream.

	* tmpstream.C (done): Removed.

	* organic_matter.C (humus): New log variable.

2004-11-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.h, select.C, select_interval.C (special_convert): New
	function.
	* select.C (initialize): Call it.
	
	* log_table.C (check): Call LogSelect::check.

	* log.C, log.h, log_all.C, log_table.C:
	* select_array.C, select.C, select_content.C:
	* select_flux_bottom.C, select_flux_top.C, select.h:
	* select_index.C, select_interval.C, select_pF.C:
	Changed geometry to soil. 

2004-11-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_hypres.C (initialize): Give error message instead of
	assertion failure for zero clay, silt, or humus.

2004-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.63 released.

2004-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* condition_time.C (ConditionTimeSyntax): Cleanup and bug fixes
	for validation.

2004-11-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.62 released.

2004-11-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_irrigate.C (check_alist): hours has a default value.

2004-10-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.61 released.

2004-10-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* rootdens.h, rootdens_G_P.C, rootdens_PLF.C: Make 'a' and 'L0'
	logable.  
	* root_system.C (output): Log them.
	* lib/log.dai ("Root form parameter"): New log parameterization. 
	* rootdens_AP.C: New model.

2004-10-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_irrigate.C (hours): Use it.
	* alist.C (integer): Add support for default value.

2004-10-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* xref.h: Use 'set' instead of 'vector' to avoid duplicates.
	* document_LaTeX.C (print_users): Update caller.

2004-10-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* canopy_std.C (CanopyStructure): Fix comment.

2004-10-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* options.C, options.h (copyright): Made is non-static.
	* treelog_dual.C, treelog_dual.h (lazy): New method.
	* options.C (copyright): Use it.
	(Options): Call copyright before parsing.
	* main.C (main): Update caller.

2004-10-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.60 released.

	* all: Include <memory> in files that uses auto_ptr.
	
2004-09-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vcheck.C (valid_hour, valid_mday, valid_month): New checks.
	* condition_time.C, action_crop.C: Use them.

	* librarian.h (create): Return pointer instead of reference.
	* root_system.h, root_system.C: 
	* pet_PM.C, pet_FAO_PM.C, organic_matter.C, options.C: 
	* log_select.C, log_select.h, log_checkpoint.C: 
	* dom.C, crop_std.C, condition_logic.C, action_wait.C: 
	* column_base.h, column_base.C, column_inorganic.C, column_std.C: 
	* action_crop.C, action_lisp.C, action_message.C: Use auto_ptr.
	* horizon.C, horizon.h: Ditto.
	* soil.C: Update caller.

	* crop_std.C: Remove extra indirection for submodels.

2004-09-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* number_const.C: New models.
	* Makefile (MODELS): Add them.

	* parser_file.C (skip_to_end): Skip whitespace first.
	(get_number): Support number objects.
	(skip_token): Hyphens are numbers, not identifiers.

	* Version 3.59 released.

2004-09-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pedo_const.C: Cleanup.

	* number.C, number.h: New component.

	* scope.h, scope.C: New utility.
	* Makefile (OTHER): Added it.

	* Version 3.58 released.

2004-09-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pedo.h, pedo.C (debug_message):  Add dimension argument.
	* equil_langmuir.C, equil_linear.C, equil_goal.C:
	* transform_equil.C (initialize):Update callers.

	* equil_goal.C (A_solute, B_solute): New parameters.
	(goal_B): Removed.

2004-09-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.57 released.

2004-09-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pedo_linear.C: Removed.
	* Makefile (REMOVE, MODELS): Remove it.
	* equil_goal.C: New models.
	* equil_langmuir.C (initialize_state): Remember whether
	initialization failed.
	* vcheck.C, vcheck.h (Compatible): New member class.
	(fraction): New static member function.
	* pedo_const.C: Added dimensions.

	* all: Don't include namespace std in header files.

2004-09-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pedo_arit.C: New model.

	* alist.C (Scalar): New value type.
	* syntax.C, syntax.h (User): New dimension.
	* horizon.C (load_syntax): Use it.
	* parser_file.C (load_list): Support it.
	(check_value): New function.
	(load_list): Use it.
	* printer_file.C (print_dimension): New function.
	(print_entry): Use it.
	* horizon.C, horizon.h (get_dimension): New function.
	* soil.C, soil.h (texture_below, get_dimension): New functions.
	* pedo_linear.C, pedo_const.C, pedo.h (value): New non-virtual
	function. 
	* pedo.C, pedo.h, pedo_linear.C, pedo_const.C (set): Made
	non-virtual. 

2004-09-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* domsorp.C, domsorp.h: New component.
	* Makefile (COMPONENTS): Added it.
	* domsorp_std.C: New model.
	* Makefile (MODELS): Added it.
	* organic_matter.C: Use it.
	* column_std.C (check_inner): Pass soil to OrganicMatter::check.

	* lib/log.dai ("Chemistry"): Renamed from "Transform".

2004-09-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.h (add): Removed one library variant.
	* action_with.C (ActionWithColumnSyntax): 
	* action_activity.C (ActionActivitySyntax): 
	* action_while.C (ActionWhileSyntax): 
	* vegetation_crops.C (VegetationCropsSyntax): 
	* equil_langmuir.C (EquilibriumLangmuirSyntax): 
	* log_select.C (load_syntax): 
	* condition_logic.C (ConditionLogicSyntax): 
	* organic_matter.C (load_syntax): Update caller.

	* solute.h (M): New member function.
	* chemistry.C, chemistry.h: New component.
	* Makefile (COMPONENTS): Added it.
	* chemistry_std.C: New model.
	* Makefile (MODELS): Added it.
	* column_base.C, column_base.h: Use it.

2004-09-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pedo.C, pedo.h (debug_message): New utility function.

	* equil_linear.C: New model.
	* Makefile (MODELS): Added it.

	* pedo_const.C: New model.
	* Makefile (MODELS): Added it.

	* transform_equil.C (k_AB, pedo_k_AB, k_BA, pedo_k_BA): Alwys use
	pedotranfer functions.

	* geometry.C (initialize_zplus): Fixed debug message.

2004-09-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transform.C, transform.h, transform_equil.C (output): Removed.
	* transform.h, transform_equil.C (tick): Make it deal with any
	soil components. 

2004-09-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.C (K_to_M): Changed warning message to debug message.

2004-09-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* root_system.C (water_stress): Fix description.

	* txt/exercises.tex (section{Calculating Hydraulic Properties}):
	Removed extra hyphen.

2004-09-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.56 released.

2004-09-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.C (tick): Set last_cut to now if unset.

2004-09-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.55 released.

2004-09-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.54 released.

2004-09-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/Makefile (reference.pdf): Make it twice, to get toc right.

	* horheat.C, horheat.h: New submodel.
	* Makefile (SUBMODELS): Add it.
	* horizon.C: Use it.

	* Version 3.53 released.

2004-09-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon_numeric.C: New model.
	* Makefile (MODELS): Add it.

2004-09-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* canopy_simple.C (CAI): Made it log only.

	* crop.h, crop.C, crop_simple.C, crop_old.C, crop_sold.C:
	* crop_std.C (initialize_organic, initialize_inorganic): Removed. 
	(initialize): New function.
	* vegetation_crops.C (initialize, sow): Update caller.

	* crop_simple.C (CropCAI): New function.
	(tick, initialize_inorganic): Use it.

	* Version 3.52 released.

2004-09-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation_crops.C (sow): Reset canopy structure for planted
	crops. 

	* horizon_system.C: New models.
	* Makefile (MODELS): Added it.

2004-09-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_Cosby.C, hydraulic_hypres.C: 
	* hydraulic.h, hydraulic.C (initialize): Take Texture argument. 
	* horizon.C (initialize_base): Update caller.

	* version.h (version_date): New global const.
	* Makefile (version.C): Generate it.
	* options.C (copyright): Use it.

	* syntax.C (is_const, is_state, is_optional, is_log): Allow
	calling with non-existing keys.
	* parser_file.C (load_list): Warn about reading log variable.


2004-09-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.51 released.

2004-09-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Total Water Balance"): Treat subsoil irrigation
	seperately. 
	("Root Zone Water Balance"): Fix sign of subsoil irrigation.

	* am.C, am.h (get_DM, get_water): New functions.
	* column_std.C (fertilize): Use them.
	* action_fertilize.C (doIt): Use them.

	* Version 3.50 released.

2004-09-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (tick): Also zero PotCanopyAss.

2004-09-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Complain if there is less than 2
	numerical layers.

	* Version 3.49 released.

2004-09-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* production.C (PotCanopyAss, CanopyAss): Made them log only.
	* canopy_simple.C (LAIvsH):Ditto.
	
	* parser_file.C (load_list): Add warning for inisitializing log
	variable. 

	* printer_file.C (print_object): Take new "original" parameter.
	(print_entry): Update caller.

	* ChangeLog.2: New file.
	* Makefile (TEXT): Added it.
	* ChangeLog: Moved version 2.* changes to ChangeLog.2.

	* root_system.C (Density, H2OExtraction, NH4Extraction,
	NO3Extraction):  Make them log only.

2004-09-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (initialize_zplus): At least three intervals in each
	horizon. 
	
	* log_all.h, log_all.C (msg): New member.
	* select_array.C, select.C, select_content.C
	* select_flux_bottom.C, select_flux_top.C, select.h
	* select_index.C, select_interval.C, select_pF.C (output_array):
	Add Treelog parameter.
	* log_all.C: Update caller.

	* sample/Makefile (DATA): Add it.
	* sample/example.gwt: New file.

	* txt/introduction.tex (subsection{The Daisy Program}): Don't
	refer to daisy.dll.

	* lib/weather.dlf: Renamed to sample/taastrup.dlf.
	* lib/test.dai: Renamed to sample/test.dai.
	* lib/Makefile, sample/Makefile: Updated.
	
	* Version 3.48 released.

2004-09-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* denitrification.C, denitrification.h (active_underground,
	active_groundwater): Removed parameter.
	(tick): Take size parameter.
	* column_std.C (tick): Update caller.

	* horizon.h, horizon.C (nitrification_): New parameter.
	* horizon.h, horizon.C, soil.C, soil.h (nitrification): New function.
	* organic_matter.C, organic_matter.h (active_size): New function. 
	* organic_matter.C (tick): Use it.
	* column_std.C (NitLog): New member class.
	(nitrification): Change to NitLog class.
	* lib/log.dai ("N Balance", "Denitrification"): Update users.

2004-09-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* nitrification.C, nitrification.h, nitrification_solute.C,
	nitrification_soil.C (tick): Split in two. 

2004-08-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* fao.C, fao.h (RefPenmanMonteith): Removed debug message and
	Treelog parameter.
	* pet_FAO_PM.C (tick): Update caller.
	* pet_PM.C (tick): Ditto.

2004-08-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/exercises.tex (section{Writing a \Daisy{} Setup File}): Use
	"(description)" for description string.

2004-08-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* sample/pedo-soil.dai: Moved dry_bulk_density from Cosby to
	HYPRES. 

2004-07-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/weather.dwf: Removed noise char.

2004-07-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C (check): Check stop time.

	* weather_std.C (check): A to.year after 9000 means no specific
	limit. 

2004-07-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* summary_simple.C (where): New parameter.

	* Version 3.47 released.

2004-07-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* sample/sample.dai: New file.
	* sample/Makefile (SETUPS): Add it.

	* parser_file.C (add_derived): Allow description strings even for
	ordered items, as long as the first member itself is not a string.

	* sample/pedo-soil.dai: New file.
	* sample/irrigation.dai: New file.
	* sample/Makefile (DAISY): Added them

	* Version 3.46 released.

2004-07-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* daisy.C, daisy.h (stop): New parameter.

	* sample/: New directory.
	* sample/Makefile: New file.
	* sample/dk-management.dai: New file.
	* Makefile (dist, cvs): Use it.

2004-07-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/Makefile (DAISY): Added it.
	* lib/dk-soil.dai: New file.

2004-06-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (output): Don't log C/N for small N.

	* Version 3.45 released.

2004-06-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (swap, mix): Added range check.

2004-06-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.44 released.

2004-06-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate.C (day_fraction): New function.
	* root_system.C, root_system.h (nitrogen_stress): Removed.
	* crpn.C, crpn.h (nitrogen_stress_days, nitrogen_stress): New
	parameters 
	* crop_std.C (tick): Update caller.
	* lib/log.dai ("Crop Production"): Updated user.

	* partition.C, partition.h (nitrogen_stress_limit): New parameter.  
	(operator ()): Use it.
	* production.C, production.h (nitrogen_stress_limit) Removed.
	(tick): Update caller.

	* Version 3.43 released.

2004-06-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* production.C, production.h (nitrogen_stress_limit) New parameter.
	(tick): Use it.
	* crop_std.C (tick): Update caller.

2004-06-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/ryegrass.dai ("Ryegrass"): Changed DSlim from 0.9.
	* lib/wclover.dai (Wclover): Ditto.

	* lib/wclover.dai, lib/ryegrass.dai: New files.
	* lib/crop.dai, lib/Makefile (NEWCROPS): Added them

2004-06-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (initialize): Use 'end' instead of 'begin'. 
	* geometry.C (mix, swap): Added const. Added check.

	* Version 3.42 released.

2004-05-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* production.C (GrowthRateRedFac): Removed parameter.
	* crop_std.C (tick): Updated user.

2004-05-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.C (operator ()): Include CH2OPool in roots.

	* Version 3.41 released.

2004-05-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.h, vegetation.C, vegetation_crops.C
	(shared_light_fraction): New virtual member.
	* vegetation_crops.C (reset_canopy_structure): Set it.
	* bioclimate_std.C (CanopyStructure): Set it.
	* bioclimate_std.C, bioclimate.h (shared_light_fraction,
	hourly_global_radiation): New virtual member.
	* crop_std.C, crop.h, crop.C (minimum_ligth_fraction): New
	virtual member. 
	(min_light_fraction): New parameter.

	* lib/dk-wrape.dai: New file.
	* lib/Makefile (DKCROPS): Add it.
	* lib/dk-crop.dai: Input it.

	* geometry.C (add): Changed assertion to warning.

2004-04-29  Per Abrahamsen  <abraham@dina.kvl.dk>
	
	* vegetation_crops.C, vegetation_permanent.C, vegetation.h (sow):
	Take seed_C parameter. 
	* column_std.C (sow): Update caller.
	(seed_C): New log variable.

	* production.C, production.h (total_C): New function.
	* crop.h (total_N): New virtual function.
	* crop_std.C (total_C): Implement it.
	* crop_sold.C (total_C): Ditto.
	* crop_simple.C (total_C): Ditto.
	* crop_old.C (total_C): Ditto.

2004-04-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.C (operator ()): Added missing "+".

	* lib/log.dai ("Total Carbon Balance"): New summary.
	("C Input"): New summary.
	("Carbon Balance"): Use them.

	* Version 3.40 released.

2004-04-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C (tillage): New log variable.
	* lib/log.dai ("Root Zone Water Balance"): Use it.
	("Total Water Balance"): Balance it.

2004-04-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (mix, swap): Add "change" parameter.
	(interval_border): Fix "off by one" error.
	* select_flux_bottom.C (output_array): Removed code that
	compensated for the error.
	* solute.h, solute.C (tillage): New log variable.
	* column_std.C, organic_matter.C, am.C, om.C (swap): Use tillage
	parameters. 
	* organic_matter.h, am.h, om.h: Ditto.
	* lib/log.dai ("Carbon Balance"): Use tillage parameters.
	("Organic Nitrogen Balance", "Nitrogen Balance", "N Balance"): Ditto.
	("NH4 Soil Balance", "NO3 Soil Balance"): Ditto.

2004-04-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* aom.h, aom.C (penetrate): Take tillage parameters.
	* organic_matter.h, organic_matter.C, am.h, am.C (mix): Ditto.
	* column_std.C (tillage_Org_N_top, tillage_Org_C_top)
	(tillage_Org_N_soil, tillage_Org_C_soil): New log variables.
	
	* column_base.C, column_std.C (clear): Clear residuals here.
	(tick_base): Not here.
	* column_base.h, column_base.C, column_std.C: Removed residuals
	log variable. 

2004-04-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.39 released.

2004-04-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transport_convection.C (tick): Bug fix, solute flux was offset
	by one compared to water flux.

2004-04-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Soil NH4-N Concentration", "Soil NH4-N Content"):
	New parameterizations.

2004-04-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C (tick): Catch string as well as char*.
	* uzrichard.C (q_darcy): More information for error.
	* groundwater_fixed.C (GroundwaterFixedSyntax): Only accept
	negative groundwater table.
	* mactrans_std.C (tick): Changed assertion to warning.

2004-03-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.38 released.

2004-03-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.37 released.

2004-03-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Nitrogen Balance"): Log dead leaves.
	("Crop Nitrogen Balance"): Include it.
	("Organic Nitrogen Balance", "Nitrogen Balance"): Ditto.

2004-03-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C (N2O_fraction): Changed to 2%.

2004-03-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.36 released.

2004-03-16  Per Abrahamsen  <abraham@dina.kvl.dk>
	
	* dom.h (water_factor): New parameter.

	* organic_matter.C (find_abiotic): Removed DOM version, changed
	AOM version to accept any OM.
	(tick): Call new DOM with new 'find_abiotic' version.

2004-03-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("NO3 Root Uptake", "NH4 Root Uptake"): New
	parameterizations. 

2004-03-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.35 released.

2004-03-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.h (FORWARD_TEMPLATES): New define.
	* all components:  Use it.

2004-03-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Chemical Content"): Renamed from "Chemicals".
	("Chemical Concentration"): New log model.

	* organic_matter.C (initialize): Clarified background
	mineralization message.
	(top_summary): Take zone_delta_N and zone_delta_C arguments.
	(initialize): Update caller.

	* units.C (standard_conversions): Added [L/kg] and [l/kg] to
	[cm^3/g] convertions.

	* lib/chemistry.dai (common): New partial parameterization.
	(Atrazine, Bentazon, IPU, MCPP, Pendimethalin, Ioxynil): Use it. 
	(fungicide, herbicide, insecticide): New partical parameterizations.

2004-03-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (find_total_input, total_input_from_am): New
	function. 
	(top_summary, initialize): Call them.

	* Version 3.34 released.

2004-03-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (top_summary): New parameter and member
	function.

	* alist.C, alist.h (name): New versions with default value.

2004-03-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C, om.h, dom.C, dom.h (soil_C, soil_N): New versions that
	take an interval argument. 

2004-03-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C (initialize): Added alternative deposition
	specifikation. 

2004-03-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Soil N Residuals", "Soil C Residuals"): Fix
	dimension. 

2004-02-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_simple.C (LAIvsTS, LAIvsDay): Fix dimensions.

2004-02-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.33 released.

2004-02-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioclimate_std.C (WaterDistribution): Change assertion to
	error. 

2004-02-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Soil N Residuals"): New log model.
	("Soil C Residuals"): New log model.

2004-02-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_base.C (harvest): No penetration for mix.

2004-02-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.32 released.

2004-02-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/potato.dai ("Potato"): Mark it as a root fruit.
	* lib/fodderbeet.dai ("Fodder Beet"): Ditto.
	* lib/sugarbeet.dai ("Sugar Beet"): Ditto.

	* canopy_std.C (CropHeight): Min height 0.1 mm.

	* vegetation.h, vegetation_crops.C
	* vegetation_permanent.C (harvest): New min_height argument. 
	* column_base.C (harvest): Use it.

	* harvesting.h, harvesting.C (sorg_height): New parameter.
	* crop.h, crop_std.C, crop_simple.C, crop_old.C, crop_sold.C
	(sorg_height): New virtual member function.

	* alist.C, alist.h (number): Version with default value.
	* all: Use it.
	* alist.C: Changed "char*" to "char *const" throughout.
	
2004-02-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.31 released.

2004-02-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lexer_data.C (skip_hyphens): Allow space at end of line with
	hyphens. 

2004-02-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (daisy.exe): Add CPPLIB.

2004-02-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* treelog_dual.C (touch, entry): Flush two.

2004-01-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.30 released.

2004-01-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_pF.C: New model.
	* Makefile (MODELS): Added it.
	
2004-01-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioincorporation.C (speed): Initialize.

	* weather_std.C (next_min_air_temperature,
	daily_min_air_temperature_): Initialize.

	* lib/log.dai ("Crop Nitrogen Balance"): New summary.

	* Version 3.29 released.

2004-01-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* root_system.C (tick_hourly): Clear 'NH4Upt' and 'NO3Upt' log
	variable. 

	* crpn.C (clear): New function.
	* crop_std.C (tick): Call it.
	
2004-01-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.28 released.

2004-01-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C (read_new_day): Initialize before first possible
	return. 

2004-01-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.27 released.

2004-01-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/wrape.dai ("Winter Rape"): Changed DSlim from 0.99 til 0.33. 
	* lib/wwheat.dai ("Winter Wheat"): Changed DSlim from 0.99 til 0.25. 
	* lib/dk-wwheat.dai ("Vinterhvede"): Ditto.
	* lib/wbarley.dai ("Winter Barley"): Ditto.
	* lib/dk-wbarley.dai ("Vinterbyg"): Ditto.
	
2004-01-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (initialize_zplus): Made it more numerically stable.

2004-01-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.26 released.

2004-01-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C (read_new_day): Handle mapping data to a period
	not in file.
	(initialize): Subtract two days from end.
	* lib/weather.dwf (End): Changed value to reflect last date.
	Removed warning about putting end a few days before.

	* Version 3.25 released.

2004-01-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: Renamed Es_reduction_factor to vapor_flux_factor.

	* adsorption_freundlich.C (M_to_C): Changed assertions to make it
	more rubust. 

2004-01-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.24 released.

2004-01-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation_permanent.C (root_system, canopy): Made them inline
	members instead of references.

	* vegetation_crops.C, vegetation_permanent.C, vegetation.h
	(litter_Es_reduction_factor, litter_water_capacity)
	(litter_albedo): New functions.
	* bioclimate_std.C (litter_ep, litter_ea): New log variables.
	(litter_water_storage): New state variable.
	(litter_water_temperature, litter_water_in, litter_water_out): New
	log variables.
	(WaterDistribution): Use them.
	(output): Output them.
	(pond_water_in, pond_water_in_temperature): Removed.
	* lib/log.dai ("Bioclimate", "Surface Water Balance"): Use them.
	("Evapotranspiration"): Ditto.

	* litter.C: New submodel.
	* Makefile (SUBMODELS): Added it.
	* vegetation_permanent.C (Litter): New submodel.

	* vegetation.C, vegetation.h (EpInterchange): Added.
	* surface.C, surface.h (EpInterchange): Removed.
	* bioclimate_std.C (WaterDistribution): Update caller.
	* vegetation_permanent.C (force_production_stress): Added.
	* vegetation.C, vegetation.h: (force_production_stress): Removed.

2004-01-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.23 released.

2004-01-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (SOM_limit_normalize): New function.
	(partition): Use it.

	* nitrification.C (N2O_fraction): Changed default from 4% to 2%.

	* Version 3.22 released.

	Lost changed changlogs from here to 3.18 due to bug in Makefile.
	
2003-12-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pet_FAO_PM.C: New model.
	* Makefile (MODELS): Added it.
	* bioclimate_std.C (initialize): Call it.

	* crop.C, crop.h, crop_std.C (rs_min, rs_max): Uncommented.
	* vegetation.h, vegetation_crops.C, vegetation_permanent.C
	(rs_min, rs_max): New functions.
	* canopy_simple.C (rs_min): Changed default value to 100.0
	* fao.C, fao.h (CanopyResistance, PenmanMonteith): New 'rs_min'
	argument. 
	* pet_PM.C (tick): Update caller.

	* vegetation_permanent.C (interception_capacity): Multiply with
	LAI.

2003-12-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.17 released.

2003-12-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation_permanent.C (YearlyLAI): New parameter.
	(VegetationPermanentSyntax): Added checks.

	* bioclimate_std.C (WaterDistribution): Changes assert to warning.

	* vegetation_permanent.C (tick): Added assertion.
	* vegetation_crops.C (reset_canopy_structure): Ditto.

	* log_table.C (LogTable): Delete summary.  Thanks valgrind.
	* soil_water.C (Implementation): Initialize 'macro'.  Thanks
	valgrind. 

	* weather_std.C (check): Add file name to error message.

	* bioclimate_std.C (initialize): Call library::check instead of
	Librarian::exist.

2003-12-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* adsorption_freundlich.C (M_to_C): Added assertions.

2003-11-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* texture.C, texture.h: New utility.
	* Makefile (OTHER): Added it.
	* horizon.C, horizon.h, horizon_std.C (texture_below): New virtual
	member function.
	* horizon.C, horizon.h (silt, sand): Removed.
	(initialize): Updated caller.
	* soil.C (clay): Updated caller.

	* units.C (standard_conversions): Added [mm/h] and [mm/d] to
	[cm/h] conversions.

	* Version 3.16 released.

2003-11-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation_permanent.C (tick): Fix C input.

	* log_alist.C, log_alist.h, log_select.h, log_select.C, log.h
	* log_harvest.C: (open_object, close_object): New function.
	* log.h (output_object): New template
	(Object): New member class.
	* pet.h (alist): New const member variable.
	* weather.h, weather.C, weather_std.C
	(has_reference_evapotranspiration): New function.
	(has_vapor_pressure, has_wind, has_min_max_temperature): New functions.
	* bioclimate_std.C (pet): Made it a pointer.
	* bioclimate_std.C, bioclimate.h (initialize): New function.
	* column_base.C (initialize_common): Call it.
	(add_bioclimate): Removed.
	(ColumnBase): Update caller.
	(output): Use 'output_object'.

2003-11-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_crop.C (doIt): Update caller.

	* condition_crop.C (ConditionDMOver): New 'height' parameter.
	* field.C, field.h (crop_dm): Ditto.
	* column.h, column_base.h, column_base.C (crop_dm): Ditto.
	* vegetation.h, vegetation_permanent.C, vegetation_crops.C
	(DM_by_name):  Ditto.
	* crop.h, crop_old.C, crop_sold.C, crop_std.C (DM): Ditto.

	* weather.C (day_cycle): Use value for middle of time step.
	(HourlyExtraterrestrialRadiation): Ditto.
	Add 12 hour offset to get max at noon, not midnight.

2003-11-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/introduction.tex: Added dimensions.

	* txt/tutorial.tex: Updated organic matter initialization and
	automatic aquitard horizon.
	* lib/test.dai: Updated.
	
2003-11-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.15 released.

2003-11-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* im.C (define_syntax): Fix 

	* Version 3.14 released.

2003-11-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (partition): Take new delta_C and delta_N
	arguments.
	(initialize): Update caller.

2003-11-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzlr.C (tick): Handle lysimeter bottom and work better with
	pressure bottoms.

2003-11-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C (standard_conversions): Accept ppm for mg N/l.
	* im.C: Handle different dimensions.
	* weather_old.C, weather.C, surface.C (load_syntax): Update caller.
	* action_irrigate.C (struct ActionIrrigate) 
	(ActionIrrigateSubsoilStartSyntax): Ditto.

	* hydraulic_Cosby.C (initialize): Added dimensions to debug
	message. 

2003-11-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C (incorporate): Renamed from 'add_external'.

	* soil_water.C, soil_water.h (incorporate): New member function.
	* soil_water.C (S_incorp): New state variable.
	* lib/log.dai ("Root Zone Water Balance"): Use it.

2003-11-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_irrigate.C (irrigate_subsoil): New command.
	* field.C, field.h, column.h, column_base.C, column_base.h
	(irrigate_subsoil): New function. 

	* hydraulic_hypres.C (initialize): Added checks.

2003-11-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_irrigate.C (ActionIrrigate): Make irrigate commands take
	'days' and 'hours' arguments and last some time.

	* action_wait.C (ActionWaitDays::doIt): Wait one hour less.
	(ActionWaitSyntax): New "wait_hours" command.

	* lib/chemistry.dai (Ioxynil): New parameterization.

	* bioincorporation.C (R_max, C_per_N_factor): Made default values
	faster.

2003-11-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.13 released.

2003-11-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C (fertilized_NO3_surface, fertilized_NH4_surface)
	(volatilization_surface): New log variables. 
	* lib/log.dai ("N Balance"): Use them.
	("Nitrogen Balance"): Ditto.

2003-10-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_std.C (fertilize): Don't add incorporated mineral
	fertilizer to fertilized_NO3 and fertilized_NH4.
	* lib/log.dai ("Nitrogen Balance"): Add incorporated to balance.
	
	* Version 3.12 released.

2003-10-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* bioincorporation.C (tick): Don't stop after first empty pool.
	(output): Fix calculation of CO2.

2003-10-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pet.h, pet_PM.C, pet_weather.C, pet_makkink.C (tick): Added time
	argument. 
	* bioclimate_std.C (WaterDistribution, tick): Ditto.
	* bioclimate.h (tick): Ditto.
	* column_inorganic.C, column_std.C (tick): Update caller.
	* pet_Hargreaves.C: New model.
	* Makefile (MODELS): Add it.
	
	* main.C (main): Don't sync with stdio.

2003-10-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C: Add support for T_min and T_max.
	* weather.C (output): Log them.
	* weather_none.C: Reindent.
	* weather_hourly.C (tick): Update daily max and min air
	temperatures. 

	* weather_std.C (initialize): Check for empty keywords.

	* Version 3.11 released.

2003-10-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* clayom_biomod.C: Updated.

2003-10-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.10 released.

2003-10-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transport_convection.C (tick): Update J[size].

	* mactrans_std.C (tick): Multiply with dz.

2003-10-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_base.C (ColumnBase): Fix initialization order.

	* options.C (Options): Support new '-l' argument.
	* options.h (get_arg): Made it public.
	* library.C, library.h (add_command, command): New functions.
	* library.h (command_fun): New typedef.
	* am.C (command_table): New function.
	(AM_Syntax): Add it.

2003-10-16  Per Abrahamsen  <abraham@dina.kvl.dk>


	* lib/dk-wbarley.dai, lib/dk-wwheat.dai, lib/dk-sbarley.dai: 
	* lib/dk-rye.dai, lib/dk-crop.dai, lib/dk-fertilizer.dai: New files.
	* lib/all.dai: Include them.
	* lib/Makefile (DKCROPS): New macro.
	(DAISY): Use it.
	* lib/fertilizer.dai (NPK01, NPK02, NP, CalciumNitrate): New
	parameterizations. 
	* lib/dk-horizon.dai: Fix comment.
	
	* crop_std.C (harvest): Added some consts.

2003-10-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.09 released.

2003-10-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_base.C (residuals_N_root, residuals_C_root): New log
	variables. 
	* lib/log.dai ("N Balance"): Log them.
	("Carbon Balance"): Ditto.
	("Organic Nitrogen Balance"): Use them.
	("Nitrogen Balance"): Ditto.

	* bioincorporation.C (C_removed, N_removed): Renamed from C and N.
	(C_added, N_added): New log variables.
	* lib/log.dai (Bioincorporation): Update caller.
	("N Balance"): Log them.
	("Nitrogen Balance"): Use it.
	("Organic Nitrogen Balance"): Use it.
	("Carbon Balance"): Update caller.

	* solute.C, solute.h (add_to_root_sink): New member function.
	* soil_chemical.C (uptake): Call it.
	* root_system.C (solute_uptake): Ditto.
	* crop_sold.C (SoluteUptake): Ditto.
	* crop_old.C (SoluteUptake): Ditto.
	* solute.C, solute.h (S_root): New member variable.
	* solute.C (output): Log it.
	(initialize): Initialize it.
	(load_syntax): Register it.
	(clear): Clear it.
	* lib/log.dai ("NH4 Soil Balance"): Use it.
	("NO3 Soil Balance"): Use it.
	("Nitrogen Balance"): Use it.
	("N Balance"): Log it.
	("N Balance"): Renamed NO3Upt and NH4Upt to NO3-Crop and
	NH4-Crop. 
	("Organic Nitrogen Balance"): Update user.

	* lib/log.dai ("Total Water Balance"): Added "Transpiration" and
	"Root Extraction". 

2003-10-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Organic Nitrogen Balance"): New summary.
	("N Balance"): Use it.
	("Nitrogen Balance"): Add caveat about zones.

2003-10-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.08 released.

2003-10-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Nitrogen Balance"): New summary.
	("N Balance"): Use it, and add a few entries to make it possible. 

	* summary_simple.C (missing): Missing datais 0.0.
	(add): Inserting missing break.

2003-09-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.07 released.

2003-09-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (heat_turnover_factor): Handle high temperature.
	* nitrification_solute.C (f_T): Ditto.
	* nitrification_soil.C (f_T): Ditto.
	* denitrification.C (f_T): Ditto.
	* chemical_std.C (heat_turnover_factor): Ditto.

2003-08-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.06 released.

2003-08-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (K_aquitard): Changed default value from 1e-4
	to 1e-3. 

	* Version 3.05 released.

2003-08-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (partition): Handle negative values in
	'SOM_fractions'. 
	* horizon.C (load_syntax): Ditto.

2003-08-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.04 released.

2003-08-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (GroundwaterPipeSyntax): Made "K_to_pipes"
	optional. 

	* lib/dk-horizon.dai: Updated.

2003-08-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.03 released.

2003-08-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (K_to_pipes): New function and parameter. 

2003-08-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* nitrification.C (NO2_fraction): New parameter.
	(NH4, NO3, N2O): Nw log variable.
	(load_syntax, output): New functions.
	* column_std.C: Ditto.
	* nitrification_solute.C: Ditto.
	* nitrification_soil.C: Update caller.
	* lib/log.dai ("N Balance"): Update.
	("Denitrification"): Ditto.

2003-07-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.02 released.

2003-07-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Root Zone Water Balance"): Fix spelling error.
	Thanks Christian Thirup.

	* log_table.C (print_initial) New flag.
	(initial_done): Use it.

2003-07-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* denitrification.C (load_syntax): Made denitrification faster.

2003-07-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather.C (Weather): Initialize T_average to 10 dg C, to
	increase chance to get Weather::check called.

2003-07-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.01 released.

2003-07-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzrichard.C (richard): Make h[0] depend on ponding for pressure
	top. 

2003-06-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 3.00 released.

2003-06-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (efficiency): New init parameter.

	* weather_std.C (PrecipScale): Renamed from PrecipCorrect.
